<template>
	<div id="overview">
		<div>
			<PageTitle
				title="發票消費數據統計"
				btn="匯出"
				class="mb-[25px]"
				@btnClick="exportData"
			/>
			<YearRangePicker class="mb-[20px]" @update="rangeChange" />
			<p class="mb-[8px] text-[12px] text-[#204BB4]">
				選取期間民國{{ range.start }}年 ~ {{ range.end }}年
			</p>
			<StatisticBlock :dataList="statisticData" />

			<!-- Mobile -->
			<template v-if="isMobile">
				<DataCard :page="page" :data="formatData" class="mt-[16px]" />
			</template>

			<!-- Desktop -->
			<template v-else>
				<DataTable :page="page" :data="formatData" class="mt-[28px]" />
			</template>
		</div>
		<div class="flex items-center justify-center py-[30px]">
			<n-pagination
				v-model:page="page"
				:page-count="totalPage"
				:on-update:page="pageChange"
			/>
		</div>
	</div>
</template>

<script setup>
import PageTitle from "@/components/Title/PageTitle.vue";
import YearRangePicker from "./components/YearRangePicker.vue";
import StatisticBlock from "@/components/StatisticBlock.vue";
import DataTable from "./components/DataTable.vue";
import DataCard from "./components/DataCard.vue";
import { NPagination } from "naive-ui/es";
import { reactive, ref } from "@vue/reactivity";
import { useRoute, useRouter } from "vue-router";
import { computed, onMounted } from "@vue/runtime-core";
import { watch } from "vue";
import { GetInoviceData } from "@/api/data";
import { reduce, map, chunk } from "lodash";
import * as XLSX from "xlsx";
import bigInt from "big-integer";
import { useWindowSize } from "@vueuse/core";

// --- Use ---
const router = useRouter();
const route = useRoute();
// --- Data ---
const perPage = 10;
const page = ref(1);
const invoiceData = ref([]);
const range = reactive({
	start: 75,
	end: 80,
});
const { width } = useWindowSize();
const mobileWidth = 768;
const isMobile = ref(false);

// --- Computed ---
const queryPage = computed(() => {
	const { query } = router.resolve(route.fullPath);
	return query.page || 1;
});

const totalPage = computed(() => {
	return Math.ceil(invoiceData.value.length / 10) || 1;
});

const formatData = computed(() => {
	const res = map(invoiceData.value, (item) => ({
		year: item["年別"],
		cate: item["稅別"],
		totalOpen: item["全年使用張數[張]"] === "-" ? 0 : item["全年使用張數[張]"],
		totalCost: item["全年銷售額[千元]"] === "-" ? 0 : item["全年銷售額[千元]"],
	}));
	return chunk(res, perPage);
});

const statisticData = computed(() => {
	const totalOpen = reduce(
		invoiceData.value,
		(acc, item) => {
			return bigInt(acc.toString()).add(
				item["全年使用張數[張]"] === "-"
					? 0
					: item["全年使用張數[張]"].toString()
			);
		},
		0
	);
	const totalMoney = reduce(
		invoiceData.value,
		(acc, item) => {
			return bigInt(acc.toString()).add(
				item["全年銷售額[千元]"] === "-"
					? 0
					: item["全年銷售額[千元]"].toString()
			);
		},
		0
	);
	return [
		{
			label: "發票總開立張數(千張)",
			type: "number",
			value: totalOpen,
		},
		{
			label: "發票總銷售金額(千元)",
			type: "money",
			value: totalMoney,
		},
	];
});
// --- Methods ---
const pageChange = (newPage) => {
	page.value = newPage;
	router.replace({
		name: route.name,
		query: {
			page: newPage,
		},
	});
};

const getInoviceData = async (start, end) => {
	const { data } = await GetInoviceData({
		start,
		end,
	});
	invoiceData.value = data;
};

const rangeChange = async (data) => {
	page.value = 1;
	range.start = data.start;
	range.end = data.end;
	await getInoviceData(data.start, data.end);
};
const saveData = (function () {
	const a = document.createElement("a");
	a.target = "_blank";

	return function (url, fileName) {
		a.setAttribute("download", fileName + ".xlsx");
		a.href = url;
		document.body.appendChild(a);
		a.click();
		document.body.removeChild(a);
		window.URL.revokeObjectURL(url);
	};
})();

const exportExcel = (data, sheetName, fileName) => {
	const ws = XLSX.utils.json_to_sheet(data);
	ws["!cols"] = [];
	ws["!cols"][2] = { hidden: true };

	/* add to workbook */
	const wb = XLSX.utils.book_new();
	XLSX.utils.book_append_sheet(wb, ws, sheetName);
	/* generate an XLSX file */
	try {
		// -- buffer
		const buf = XLSX.write(wb, { type: "buffer", bookType: "xlsx" });
		// const buftype = 'application/vnd.ms-excel;charset=utf-8';
		const buftype =
			"application/vnd.openxmlformats-officedocument.spreadsheetml.sheet";
		const blob = new Blob([buf], {
			type: buftype,
		});
		const url = URL.createObjectURL(blob);
		saveData(url, fileName);
	} catch (error) {
		console.log("export error", error);
	}
};

const exportData = async () => {
	const allData = await GetInoviceData({
		start: 75,
		end: 109,
	});
	return await exportExcel(allData.data, "Data", "Invoice");
	// code here
};
// --- Mounted ---
onMounted(() => {
	page.value = Number(queryPage.value);
	isMobile.value = width.value < mobileWidth ? true : false;
});

watch(width, (newWidth) => {
	isMobile.value = newWidth < mobileWidth ? true : false;
});
</script>

<style scoped lang="postcss">
#overview {
	@apply flex flex-col justify-between h-full;
}
</style>
